/**@file
 *			Patched by G-HAL
 *@brief	եϤˤ륨ǥѴ
 *@date		Thu,06 Dec,2012 - Fri,14 Dec,2012, Tue,18 Dec,2012
 *@author	Copyright(C)2012 G-HAL
 */
#ifndef _record_valconv_h_included_
#define _record_valconv_h_included_

#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif

#if defined(HAVE_STDLIB_H)
# include <stdlib.h>
#endif
#if defined(HAVE_STDBOOL_H)
# include <stdbool.h>
#endif
#if !defined(__STDC_LIMIT_MACROS)
# define __STDC_LIMIT_MACROS
#endif
#if !defined(__STDC_CONSTANT_MACROS)
# define __STDC_CONSTANT_MACROS
#endif
#if defined(HAVE_STDINT_H)
# include <stdint.h>
#endif
#if defined(HAVE_STDIO_H)
# include <stdio.h>
#endif
#if defined(HAVE_ARPA_INET_H)
# include <arpa/inet.h>
#endif
#if defined(HAVE_SYS_TYPES_H)
# include <sys/types.h>
#endif
#if defined(HAVE_NETINET_IN_H)
# include <netinet/in.h>
#endif
#if defined(HAVE_INTTYPES_H)
# include <inttypes.h>
#endif
#if defined(HAVE_SYS_ENDIAN_H)
# include <sys/endian.h>
#endif
#if defined(HAVE_ENDIAN_H)
# include <endian.h>
#endif



#ifdef __cplusplus
extern "C" {
#endif

typedef union {
  uint8_t u8;
  uint16_t u16;
  uint32_t u32;
  uint64_t u64;
  int8_t s8;
  int16_t s16;
  int32_t s32;
  int64_t s64;
} type_punned_cast_t;

typedef union {
  void* vp;
  uint8_t* u8p;
  uint16_t* u16p;
  uint32_t* u32p;
  uint64_t* u64p;
  int8_t* s8p;
  int16_t* s16p;
  int32_t* s32p;
  int64_t* s64p;
} type_punned_pointer_cast_t;



/** uint8_t Хʥɤ߹
 *@param[in]		fp			ϥե
 *@return					ɹ
 *
 *@author	G-HAL
 *@date		Thu,16 Oct,2008
 */
static inline uint8_t fread_uint8( FILE* const fp )
{
  uint8_t data;
  fread( &data, 1, 1, fp );
  return data;
}

/** uint16_t Хʥɤ߹
 *@param[in]		fp			ϥե
 *@return					ɹ
 *
 *@author	G-HAL
 *@date		Thu,16 Oct,2008
 */
static inline uint16_t fread_uint16( FILE* const fp )
{
  uint16_t data;
  fread( &data, 2, 1, fp );
  return ntohs(data);
}

/** uint32_t Хʥɤ߹
 *@param[in]		fp			ϥե
 *@return					ɹ
 *
 *@author	G-HAL
 *@date		Thu,16 Oct,2008
 */
static inline uint32_t fread_uint32( FILE* const fp )
{
  uint32_t data;
  fread( &data, 4, 1, fp );
  return ntohl(data);
}

/** uint64_t Хʥɤ߹
 *@param[in]		fp			ϥե
 *@return					ɹ
 *
 *@author	G-HAL
 *@date		Thu,16 Oct,2008, Mon,20 Oct,2008
 *@date		Sat,08 Dec,2012, Wed,12 Dec,2012 - Thu,13 Dec,2012, Tue,18 Dec,2012
 */
static inline uint64_t fread_uint64( FILE* const fp )
{
 #if defined(HAVE_DECL_BETOH64) && HAVE_DECL_BETOH64
  uint64_t data;
  fread( &data, 8, 1, fp );
  return betoh64(data);
 #else
 # if defined(CHARARRAY_IS_CONTINUOUS8BIT)
  uint8_t buf[8];
  fread( buf, 8, 1, fp );
 #  ifdef __cplusplus
  register type_punned_pointer_cast_t tppc;
  tppc.u8p = &(buf[0]); const uint32_t data_u = *tppc.u32p;
  tppc.u8p = &(buf[4]); const uint32_t data_d = *tppc.u32p;
 #  else
  const uint32_t data_u = *((type_punned_pointer_cast_t)&(buf[0])).u32p;
  const uint32_t data_d = *((type_punned_pointer_cast_t)&(buf[4])).u32p;
 #  endif
  return (((uint64_t)ntohl(data_u)) << 32) | ((uint64_t)ntohl(data_d));
 # else
  uint32_t u;
  uint32_t d;
  fread( &u, 4, 1, fp );
  fread( &d, 4, 1, fp );
  return ((uint64_t)ntohl(u) << 32) + ((uint64_t)ntohl(d) <<  0);
 # endif
 #endif
}

/** ĹͤХʥɤ߹
 *@param		type			ɹĹ
 *@param[in]		fp			ϥե
 *@return					ɹ
 *
 *@author	G-HAL
 *@date		Sun,19 Oct,2008, Mon,20 Oct,2008, Tue,21 Oct,2008
 *@date		Sat,08 Dec,2012, Wed,12 Dec,2012 - Thu,13 Dec,2012, Tue,18 Dec,2012
 */
static inline uint64_t fread_uintv64_core( uint8_t type, FILE* const fp )
{
 #if defined(CHARARRAY_IS_CONTINUOUS8BIT)
  uint8_t buf[8];

  {
   #ifdef __cplusplus
    register type_punned_pointer_cast_t tppc;
    tppc.u8p = &(buf[0]); *tppc.u64p = 0;
   #else
    *((type_punned_pointer_cast_t)buf).u64p = 0;
   #endif
  }
  fread( &(buf[8-type]), type, 1, fp );
  uint64_t ret;
  if (type <= 4) {
   #ifdef __cplusplus
    register type_punned_pointer_cast_t tppc;
    tppc.u8p = &(buf[4]); const uint32_t data = *tppc.u32p;
   #else
    const uint32_t data = *((type_punned_pointer_cast_t)&(buf[4])).u32p;
   #endif
    ret = (uint64_t)ntohl(data);
  } else {
   #ifdef __cplusplus
    register type_punned_pointer_cast_t tppc;
   # if defined(HAVE_DECL_BETOH64) && HAVE_DECL_BETOH64
    tppc.u8p = &(buf[0]); const uint64_t data = *tppc.u64p;
    ret = betoh64(data);
   # else
    tppc.u8p = &(buf[0]); const uint32_t data_u = *tppc.u32p;
    tppc.u8p = &(buf[4]); const uint32_t data_d = *tppc.u32p;
    ret = (((uint64_t)ntohl(data_u)) << 32) | ((uint64_t)ntohl(data_d));
   # endif
   #else
   # if defined(HAVE_DECL_BETOH64) && HAVE_DECL_BETOH64
    const uint64_t data = *((type_punned_pointer_cast_t)&(buf[0])).u64p;
    ret = betoh64(data);
   # else
    const uint32_t data_u = *((type_punned_pointer_cast_t)&(buf[0])).u32p;
    const uint32_t data_d = *((type_punned_pointer_cast_t)&(buf[4])).u32p;
    ret = (((uint64_t)ntohl(data_u)) << 32) | ((uint64_t)ntohl(data_d));
   # endif
   #endif
  }
 #else
  uint64_t ret = 0;
  uint8_t buf;
  size_t len;
  for (len = 0; len < type; ++len) {
    fread( &buf, 1, 1, fp );
    ret = (ret << 8) + (uint64_t)buf;
  }
 #endif
  return ret;
}
/** ĹͤХʥɤ߹
 *@param[in]		fp			ϥե
 *@return					ɹ
 *
 *@author	G-HAL
 *@date		Sun,19 Oct,2008, Mon,20 Oct,2008, Tue,21 Oct,2008
 */
static inline uint64_t fread_uintv64( FILE* const fp )
{
  uint8_t type;
  fread( &type, 1, 1, fp );
  if (8 < type) {
    anthy_log(0, "Failed to parse a length identifier in read_session_bin().\n" );
    return 0;
  }
  return fread_uintv64_core( type, fp );
}

/** դĹͤХʥɤ߹
 *@param[out]		sign			ɹͤ
 *@param[in]		fp			ϥե
 *@return					ɹ
 *
 *@author	G-HAL
 *@date		Tue,21 Oct,2008
 *@date		Sat,08 Dec,2012, Wed,12 Dec,2012 - Fri,14 Dec,2012, Tue,18 Dec,2012
 */
static inline uint64_t fread_xintv64( int* const sign, FILE* const fp )
{
 #if defined(CHARARRAY_IS_CONTINUOUS8BIT)
  uint8_t type;
  uint8_t buf[8];
  fread( &type, 1, 1, fp );
  if (0 == (UINT8_C(0x80) & type)) {
    *sign = 0;
    if (8 < type) {
      anthy_log(0, "Failed to parse a length identifier in read_session_bin().\n" );
      return 0;
    }
    return fread_uintv64_core( type, fp );
  }
  *sign = 1;
  type &= UINT8_C(0x7F);
  if (8 < type) {
    anthy_log(0, "Failed to parse a length identifier in read_session_bin().\n" );
    return 0;
  }

  {
   #ifdef __cplusplus
    register type_punned_pointer_cast_t tppc;
    tppc.u8p = &(buf[0]); *tppc.s64p = -1;
   #else
    *((type_punned_pointer_cast_t)&(buf[0])).s64p = -1;
   #endif
  }
  fread( &(buf[8-type]), type, 1, fp );
  uint64_t ret;
  if (type <= 4) {
   #ifdef __cplusplus
    register type_punned_pointer_cast_t tppc;
    tppc.u8p = &(buf[4]); const uint32_t data = *tppc.u32p;
   #else
    const uint32_t data = *((type_punned_pointer_cast_t)&(buf[4])).u32p;
   #endif
    ret = (int32_t)ntohl(data);
  } else {
   #ifdef __cplusplus
    register type_punned_pointer_cast_t tppc;
   # if defined(HAVE_DECL_BETOH64) && HAVE_DECL_BETOH64
    tppc.u8p = &(buf[0]); const uint64_t data = *tppc.u64p;
    ret = betoh64(data);
   # else
    tppc.u8p = &(buf[0]); const uint32_t data_u = *tppc.u32p;
    tppc.u8p = &(buf[4]); const uint32_t data_d = *tppc.u32p;
    ret = (((uint64_t)ntohl(data_u)) << 32) | ((uint64_t)ntohl(data_d));
   # endif
   #else
   # if defined(HAVE_DECL_BETOH64) && HAVE_DECL_BETOH64
    const uint64_t data = *((type_punned_pointer_cast_t)&(buf[0])).u64p;
    ret = betoh64(data);
   # else
    const uint32_t data_u = *((type_punned_pointer_cast_t)&(buf[0])).u32p;
    const uint32_t data_d = *((type_punned_pointer_cast_t)&(buf[4])).u32p;
    ret = (((uint64_t)ntohl(data_u)) << 32) | ((uint64_t)ntohl(data_d));
   # endif
   #endif
  }
 #else
 # error	"Not implemented, yet."
 #endif
  return ret;
}


/** uint8_t Хʥ¸
 *@param		data			
 *@param[in]		fp			ϥե
 *
 *@author	G-HAL
 *@date		Thu,16 Oct,2008
 */
static inline void fwrite_uint8( const uint8_t data, FILE* const fp )
{
	fwrite( &data, 1, 1, fp );
	return;
}

/** uint16_t Хʥ¸
 *@param		data			
 *@param[in]		fp			ϥե
 *
 *@author	G-HAL
 *@date		Thu,16 Oct,2008
 */
static inline void fwrite_uint16( const uint16_t data, FILE* const fp )
{
	const uint16_t n = htons(data);
	fwrite( &n, 2, 1, fp );
	return;
}

/** uint32_t Хʥ¸
 *@param		data			
 *@param[in]		fp			ϥե
 *
 *@author	G-HAL
 *@date		Thu,16 Oct,2008
 */
static inline void fwrite_uint32( const uint32_t data, FILE* const fp )
{
	const uint32_t n = htonl(data);
	fwrite( &n, 4, 1, fp );
	return;
}

/** uint64_t Хʥ¸
 *@param		data			
 *@param[in]		fp			ϥե
 *
 *@author	G-HAL
 *@date		Thu,16 Oct,2008, Mon,20 Oct,2008
 *@date		Sat,08 Dec,2012, Wed,12 Dec,2012 - Thu,13 Dec,2012, Tue,18 Dec,2012
 */
static inline void fwrite_uint64( const uint64_t data, FILE* const fp )
{
  #if defined(HAVE_DECL_HTOBE64) && HAVE_DECL_HTOBE64
	const uint64_t n = htobe64(data);
	fwrite( &n, 8, 1, fp );
	return;
  #else
  # if defined(CHARARRAY_IS_CONTINUOUS8BIT)
	uint8_t buf[8];
  #  ifdef __cplusplus
	register type_punned_pointer_cast_t tppc;
	tppc.u8p = &(buf[0]); *tppc.u32p = htonl((data >> 32) & UINT32_C(0xFFFFFFFF));
	tppc.u8p = &(buf[4]); *tppc.u32p = htonl(data & UINT32_C(0xFFFFFFFF));
  #  else
	*((type_punned_pointer_cast_t)&(buf[0])).u32p = htonl((data >> 32) & UINT32_C(0xFFFFFFFF));
	*((type_punned_pointer_cast_t)&(buf[4])).u32p = htonl(data & UINT32_C(0xFFFFFFFF));
  #  endif
	fwrite( buf, 8, 1, fp );
  # else
  #  error	"Not implemented, yet."
  # endif
  #endif
	return;
}

/** ̵ĹͤХʥ¸
 *@param		data			
 *@param[in]		fp			ϥե
 *
 *@author	G-HAL
 *@date		Sun,19 Oct,2008, Mon,20 Oct,2008
 *@date		Sat,08 Dec,2012, Wed,12 Dec,2012 - Thu,13 Dec,2012, Tue,18 Dec,2012
 */
static inline void fwrite_uintv64( const uint64_t data, FILE* const fp )
{
  #if defined(CHARARRAY_IS_CONTINUOUS8BIT)
	uint8_t buf[8];
	uint8_t len;
  #ifdef __cplusplus
	register type_punned_pointer_cast_t tppc;
  # if defined(HAVE_DECL_HTOBE64) && HAVE_DECL_HTOBE64
	tppc.u8p = &(buf[0]); *tppc.u64p = htobe64(data);
  # else
	tppc.u8p = &(buf[0]); *tppc.u32p = htonl((data >> 32) & ((((uint64_t)1) << 32)-1));
	tppc.u8p = &(buf[4]); *tppc.u32p = htonl(data & ((((uint64_t)1) << 32)-1));
  # endif
  #else
  # if defined(HAVE_DECL_HTOBE64) && HAVE_DECL_HTOBE64
	*((type_punned_pointer_cast_t)&(buf[0])).u64p = htobe64(data);
  # else
	*((type_punned_pointer_cast_t)&(buf[0])).u32p = htonl((data >> 32) & ((((uint64_t)1) << 32)-1));
	*((type_punned_pointer_cast_t)&(buf[4])).u32p = htonl(data & ((((uint64_t)1) << 32)-1));
  # endif
  #endif
	if (data < (((uint64_t)1) << (8*4))) {
		if (data < (((uint64_t)1) << (8*2))) {
			if (data < (((uint64_t)1) << (8*1))) {
				buf[6] = 1;
				fwrite( &(buf[6]), 2, 1, fp );
			} else {
				buf[5] = 2;
				fwrite( &(buf[5]), 3, 1, fp );
			}
		} else {
			if (data < (((uint64_t)1) << (8*3))) {
				buf[4] = 3;
				fwrite( &(buf[4]), 4, 1, fp );
			} else {
				buf[3] = 4;
				fwrite( &(buf[3]), 5, 1, fp );
			}
		}
	} else {
		if (data < (((uint64_t)1) << (8*6))) {
			if (data < (((uint64_t)1) << (8*5))) {
				buf[2] = 5;
				fwrite( &(buf[2]), 6, 1, fp );
			} else {
				buf[1] = 6;
				fwrite( &(buf[1]), 7, 1, fp );
			}
		} else {
			if (data < (((uint64_t)1) << (8*7))) {
				buf[0] = 7;
				fwrite( &(buf[0]), 8, 1, fp );
			} else {
				len = 8;
				fwrite( &len, 1, 1, fp );
				fwrite( &(buf[0]), 8, 1, fp );
				/*
				 * buf[] γݤ char buf[9] Ȥäơ
				 *	buf[0] = '8';
				 *	fwrite( &(buf[0]), 9, 1, fp );
				 * ȤȤȡƬ
				 *	(*(uint32_t* const)&(buf[1]))
				 * ǥ饤ȰȿˤʤϤ롣
				 *  HP-UX Ȥ ARM ȤΤꡣ
				 */
			}
		}
	}
	return;
  #else
  # error	"Not implemented, yet."
  #endif
}


/** ͭĹͤХʥ¸
 *@param		data			
 *@param[in]		fp			ϥե
 *
 *@author	G-HAL
 *@date		Tue,21 Oct,2008
 *@date		Sat,08 Dec,2012, Wed,12 Dec,2012 - Thu,13 Dec,2012, Tue,18 Dec,2012
 */
static inline void fwrite_sintv64( const int64_t data, FILE* const fp )
{
  #if defined(CHARARRAY_IS_CONTINUOUS8BIT)
	uint8_t buf[8];
	uint8_t len;
	if (0 <= data) {
		fwrite_uintv64( data, fp );
		return;
	}
  #ifdef __cplusplus
	register type_punned_pointer_cast_t tppc;
  # if defined(HAVE_DECL_HTOBE64) && HAVE_DECL_HTOBE64
	tppc.u8p = &(buf[0]); *tppc.u64p = htobe64(data);
  # else
	tppc.u8p = &(buf[0]); *tppc.u32p = htonl((data >> 32) & ((((uint64_t)1) << 32)-1));
	tppc.u8p = &(buf[4]); *tppc.u32p = htonl(data & ((((uint64_t)1) << 32)-1));
  # endif
  #else
  # if defined(HAVE_DECL_HTOBE64) && HAVE_DECL_HTOBE64
	*((type_punned_pointer_cast_t)&(buf[0])).u64p = htobe64(data);
  # else
	*((type_punned_pointer_cast_t)&(buf[0])).u32p = htonl((data >> 32) & ((((uint64_t)1) << 32)-1));
	*((type_punned_pointer_cast_t)&(buf[4])).u32p = htonl(data & ((((uint64_t)1) << 32)-1));
  # endif
  #endif
	if ((((int64_t)0) - (((int64_t)1) << (8*4))) <= data) {
		if ((((int64_t)0) - (((int64_t)1) << (8*2))) <= data) {
			if ((((int64_t)0) - (((int64_t)1) << (8*1))) <= data) {
				buf[6] = 1 | UINT8_C(0x80);
				fwrite( &(buf[6]), 2, 1, fp );
			} else {
				buf[5] = 2 | UINT8_C(0x80);
				fwrite( &(buf[5]), 3, 1, fp );
			}
		} else {
			if ((((int64_t)0) - (((int64_t)1) << (8*3))) <= data) {
				buf[4] = 3 | UINT8_C(0x80);
				fwrite( &(buf[4]), 4, 1, fp );
			} else {
				buf[3] = 4 | UINT8_C(0x80);
				fwrite( &(buf[3]), 5, 1, fp );
			}
		}
	} else {
		if ((((int64_t)0) - (((int64_t)1) << (8*6))) <= data) {
			if ((((int64_t)0) - (((int64_t)1) << (8*5))) <= data) {
				buf[2] = 5 | UINT8_C(0x80);
				fwrite( &(buf[2]), 6, 1, fp );
			} else {
				buf[1] = 6 | UINT8_C(0x80);
				fwrite( &(buf[1]), 7, 1, fp );
			}
		} else {
			if ((((int64_t)0) - (((int64_t)1) << (8*7))) <= data) {
				buf[0] = 7 | UINT8_C(0x80);
				fwrite( &(buf[0]), 8, 1, fp );
			} else {
				len = 8 | UINT8_C(0x80);
				fwrite( &len, 1, 1, fp );
				fwrite( &(buf[0]), 8, 1, fp );
			}
		}
	}
	return;
  #else
  # error	"Not implemented, yet."
  #endif
}


#ifdef __cplusplus
}
#endif

#endif /* _record_valconv_h_included_ */
/* [ End of File ] */
/* vim:ts=4 sw=4 nomodified:
 */
